--init.lua
--all the goods go here
AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

ENT.stage = 0
ENT.dirt = false
ENT.water = false
ENT.plant = ""
ENT.passes = 0

util.AddNetworkString( "create_cs_timer_for_pct" )
util.AddNetworkString( "spawn_the_drug_because_done" )

function ENT:Initialize()
	self:SetModel("models/nater/weedplant_pot.mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then phys:Wake() end
	self:SetUseType(SIMPLE_USE)
	self:SetPos(Vector(self:GetPos().x, self:GetPos().y, self:GetPos().z + 50))
end

function ENT:ChangeModel(drug)
	if self.stage != nil and self.plant != "" then
		if self.stage < 7 then
			self.stage = self.stage + 1
			net.Start( "create_cs_timer_for_pct" )
				net.WriteInt( self.stage, 32 )
				net.WriteEntity( self )
				net.WriteString( self.plant )
			net.Broadcast()
		else return end
		if IsValid(self) and self.stage != nil then
		
			timer.Simple(25, function()
				net.Start( "create_cs_timer_for_pct" )
					net.WriteInt( self.stage, 32 )
					net.WriteEntity( self )
					net.WriteString( self.plant )
				net.Broadcast()
				if self.stage != nil then
					self:ChangeModel(self.stage + 1) end end )
					
		else return end
	end
	self:SetModel("models/nater/weedplant_pot_growing" .. tostring(drug) .. ".mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then phys:Wake() end
end

function ENT:PhysicsCollide(cd, col)
	if cd.HitEntity:GetClass() == "st_dirt" and self.dirt == false and self.water == false then
		self:SetModel("models/nater/weedplant_pot_dirt.mdl")
		self:PhysicsInit(SOLID_VPHYSICS)
		self:SetMoveType(MOVETYPE_VPHYSICS)
		self:SetSolid(SOLID_VPHYSICS)
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then phys:Wake() end
		self.dirt = true
		timer.Simple(0, function() cd.HitEntity:Remove() end)
		self:EmitSound("player/footsteps/gravel" .. math.random(1,4) .. ".wav")
	end
	
	if cd.HitEntity:GetClass() == "durgz_water" and self.dirt == true and self.water == false then
		self.water = true
		timer.Simple(0, function() cd.HitEntity:Remove() end)
		self:EmitSound("ambient/levels/canals/drip".. tostring(math.random(1,4)) .. ".wav")
	end
	
	if cd.HitEntity:GetClass() == "st_coca" and self.dirt == true and self.water == true and self.plant == "" then
		self.plant = "cocaine"
		timer.Simple(0, function() cd.HitEntity:Remove() end)
		self:SetModel("models/nater/weedplant_pot_planted.mdl")
		self:PhysicsInit(SOLID_VPHYSICS)
		self:SetMoveType(MOVETYPE_VPHYSICS)
		self:SetSolid(SOLID_VPHYSICS)
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then phys:Wake() end
		self:EmitSound("player/footsteps/grass" .. math.random(1,4) .. ".wav")
	elseif cd.HitEntity:GetClass() == "st_tobseed" and self.dirt == true and self.water == true and self.plant == "" then
		self.plant = "tobacco"
		timer.Simple(0, function() cd.HitEntity:Remove() end)
		self:SetModel("models/nater/weedplant_pot_planted.mdl")
		self:PhysicsInit(SOLID_VPHYSICS)
		self:SetMoveType(MOVETYPE_VPHYSICS)
		self:SetSolid(SOLID_VPHYSICS)
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then phys:Wake() end
		self:EmitSound("player/footsteps/grass" .. math.random(1,4) .. ".wav")
	elseif cd.HitEntity:GetClass() == "st_weedseed" and self.dirt == true and self.water == true and self.plant == "" then
		self.plant = "weed"
		timer.Simple(0, function() cd.HitEntity:Remove() end)
		self:SetModel("models/nater/weedplant_pot_planted.mdl")
		self:PhysicsInit(SOLID_VPHYSICS)
		self:SetMoveType(MOVETYPE_VPHYSICS)
		self:SetSolid(SOLID_VPHYSICS)
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then phys:Wake() end
		self:EmitSound("player/footsteps/grass" .. math.random(1,4) .. ".wav")
	elseif cd.HitEntity:GetClass() == "st_spores" and self.dirt == true and self.water == true and self.plant == "" then
		self.plant = "mushroom"
		timer.Simple(0, function() cd.HitEntity:Remove() end)
		self:SetModel("models/nater/weedplant_pot_planted.mdl")
		self:PhysicsInit(SOLID_VPHYSICS)
		self:SetMoveType(MOVETYPE_VPHYSICS)
		self:SetSolid(SOLID_VPHYSICS)
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then phys:Wake() end
		self:EmitSound("player/footsteps/grass" .. math.random(1,4) .. ".wav")
	end

end

function ENT:OnRemove()
	
end

function ENT:Think()
	if self.plant != "" and self.stage < 7 and IsValid(self) and self.passes == 0 and self.stage != nil then
		timer.Simple(25, function() 
			if self.stage != nil then
				self:ChangeModel(self.stage + 1) end end )
		net.Start( "create_cs_timer_for_pct" )
			net.WriteInt( self.stage, 32 )
			net.WriteEntity( self )
			net.WriteString( self.plant )
		net.Broadcast()
		self.passes = 1
	end
	if self.plant == "" and self.stage == 0 and self.dirt == true and self.water == true then
		self:SetModel("models/nater/weedplant_pot_dirt.mdl")
	end
end

function ENT:Use(act, ply)
	
end

net.Receive( "spawn_the_drug_because_done", function()

	local me = net.ReadEntity()
	if me.stage != 7 then return end
	if me.plant == "cocaine" then
		me:SetModel("models/nater/weedplant_pot_dirt.mdl")
		local cocaine = ents.Create("durgz_cocaine")
		if !IsValid(cocaine) then return end
		cocaine:SetPos(Vector(me:GetPos().x, me:GetPos().y, me:GetPos().z + 20))
		cocaine:Spawn()
	elseif me.plant == "tobacco" then
		me:SetModel("models/nater/weedplant_pot_dirt.mdl")
		local tobacco = ents.Create("durgz_cigarette")
		if !IsValid(tobacco) then return end
		tobacco:SetPos(Vector(me:GetPos().x, me:GetPos().y, me:GetPos().z + 20))
		tobacco:Spawn()
	elseif me.plant == "weed" then
		me:SetModel("models/nater/weedplant_pot_dirt.mdl")
		local weed = ents.Create("durgz_weed")
		if !IsValid(weed) then return end
		weed:SetPos(Vector(me:GetPos().x, me:GetPos().y, me:GetPos().z + 20))
		weed:Spawn()
	elseif me.plant == "mushroom" then
		me:SetModel("models/nater/weedplant_pot_dirt.mdl")
		local shroom = ents.Create("durgz_mushroom")
		if !IsValid(shroom) then return end
		shroom:SetPos(Vector(me:GetPos().x, me:GetPos().y, me:GetPos().z + 50))
		shroom:Spawn()
	else return end
	me.stage = 0
	me.plant = ""
	me.passes = 0
	me:SetModel("models/nater/weedplant_pot_dirt.mdl")

end )